<?php defined('SYSPATH') OR die('No direct access allowed.');
/*
 *
 * @packpage	Arlicle
 * @author 		Edison Rao
 * @copyright 	(c) 2009 Arlicle Team
 * @license 	GNU General Public License 2.0
 */
class Backup_Theme_Data_Controller extends Controller {

    public function index($status = '') {
        $theme = Kohana::config('config.theme');
        $data_file = APPPATH . "themes/$theme/application/data/data.php";
        $arlicle_path = "/webroot/themes/$theme/application/data/data.php";
        if ($_POST) {
            $this->db = new Database();
            $tables = array('diagrams', 'customfields', 'customvalues', 'posts', 'attachments');
            $output = "<?php defined('SYSPATH') OR die('No direct access allowed.');\n\n";
            foreach($tables as $table) {
                $output .= $this->_write_data($table);
            }
            $output .= "\n?>";
            // check the ability
            if (!is_file($data_file)) {
                url::admin_redirect('backup_theme_data/index/exists_failed');
            } else {
                if (!is_writable($data_file)) {
                    url::admin_redirect('backup_theme_data/index/writable_failed');
                } else {
                    $handle = fopen($data_file, 'w+');
                    fwrite($handle, $output);
                    fclose($handle);
                    Tip::set('Backup done.');
                    url::admin_redirect('backup_theme_data');
                }
            }
        }

        $view = new View('layouts/admin');
        $view->page_title = 'Backup theme data';
        $view->status = $status;
        $view->data_file = $arlicle_path;
        $view->render(true);
    }

    protected function _write_data($table_name) {
        $results = $this->db->from($table_name)->get();
        $count = count($results);
        if (empty($count)) {
            return '';
        }
        $fields = $this->db->list_fields($table_name);
        $fields_count = count($fields);

        $search = array("\\", "'", "\x00", "\x0a", "\x0d", "\x1a", '"', '$');
        $replace = array("\\\\", "\\'", '\0', '\n', '\r', '\Z', '\\"', '\$');
        $fields_array = array_keys($fields);
        $fields_list = '';
        foreach($fields_array as $field) {
            $fields_list .= '`' . $field . '`,';
        }
        $fields_list = trim($fields_list, ',');

        $sql_data = "// data from $table_name\n";
        $sql_data .= '$db->query("INSERT INTO `{$prefix}' . $table_name . '` (' . $fields_list . ') VALUES ' . "\n";

        $i = 1;
        # write each filed value
        foreach($results as $row) {
            $sql_data .= '(';
            $values = array();
            foreach($fields as $key => $field) {
                if (!isset($row->$key) || is_null($row->$key)) {
                    $values[$key] = 'NULL';
                } else if ($field['type'] == 'int') {
                    $values[$key] = $row->$key;
                } else {
                    $values[$key] = "'" . str_replace($search, $replace, $row->$key) . "'";
                }
            }
            $ext = ',';
            if ($i == $count) {
                $ext = ';';
            }
            $i++;
            $sql_data .= implode(', ', $values) . ')' . $ext . "\n";
        }
        $sql_data .= '");' . "\n\n";
        return $sql_data;
    }
}
