<?php defined('SYSPATH') OR die('No direct access allowed.');
/**
 * Get the site diagram.
 * list the diagram.
 * show the manage buttom on the diagram.
 */

class Diagram_Core {
    public static $diagrams;
    public static $parent_diagrams;
    public static $instance;
    public static $post_diagrams;
    protected static $tmp_diagrams = array();

	/**
	 * Cache current diagram list by parent_id.
	 *
	 */
    public static function cache_diagram() {
        if (!is_array(self::$diagrams)) {
            $diagrams = ORM::factory('diagram')->find_all();
            $count = count($diagrams);
            if (empty($count)) {
                return array();
            }

            for ($i = 0; $i < $count; $i++) {
                if(empty($diagrams[$i])) {
                    break;
                }
                self::$parent_diagrams[$diagrams[$i]->parent_id][] = $diagrams[$i];
                self::$diagrams[$diagrams[$i]->id] = $diagrams[$i];
            }
        }
    }

	/**
	 * get the diagram list as ul and li.
	 *
	 * @param  string  for admin manage
	 */
    public static function draw_diagram($action = '') {
        self::cache_diagram();
        return self::get_diagram_list(0, 0, $action);
    }

    public static function get_diagram_list($parent_id = 0, $level = 0, $action = 'manage') {
        $list = '';
        if (empty(self::$parent_diagrams[$parent_id])) {
            return $list;
        }
        if ($parent_id != 0) {
            $list = "\n<ul>\n";
        } else {
            $list = '<ul id="browser" class="filetree">';
        }
        $authentic = new Auth;
        $user = $authentic->get_user();
        foreach (self::$parent_diagrams[$parent_id] as $diagram) {
            $list .= '<li><span class="' . $diagram->type . '" id="diagram_' . $diagram->id . '">' . $diagram->title;
            $list .= '<span class="diagram_action">';
            if ($action == 'manage' && $user->can('manage_diagram')) {
                $list .= '<span>' . html::admin_anchor('/diagram_manage/move/up/' . $diagram->id, T::_('Move up')) . '</span>';
                $list .= '<span>' . html::admin_anchor('/diagram_manage/move/down/' . $diagram->id, T::_('Move down')) . '</span>';
                $list .= '<span>' . html::admin_anchor('/diagram_manage/diagram_new/' . $diagram->id . '/add_a_child', T::_('Add child')) . '</span>';
                $list .= '<span>' . html::admin_anchor('/diagram_manage/delete/' . $diagram->id, T::_('Delete'), array('onclick'=>"return confirm('" . T::_('Are you sure you want to delete it?') . "')")) . '</span>';
                $list .= '<span>' . html::admin_anchor('/diagram_manage/diagram_new/' . $diagram->id . '/edit/', T::_('Edit'))  . '</span>';
            } else {
                $other_action = '';
                $title = '';
                $url = '';
                switch($diagram->type) {
                    case 'page':
                        if ($user->can('edit_page')) {
                            $title = T::_('Edit');
                            $url = "/diagram/page_edit/$diagram->id/edit/?redirect_uri=" . Router::$complete_uri;
                        }
                        break;
                    case 'list':
                        $title = T::_('Post New');
                        $url = "/post_new/$diagram->id/add_from_diagram";
                        $other_action = ' <span>' . html::admin_anchor('/posts/' . $diagram->id, T::_('Manage posts')) . '</span>';
                        break;
                    case 'item':
                    case 'url':
                    default:
                        $title = '';
                        $url = '';
                }
                $list .= ' <span>' . html::admin_anchor($url, $title) . '</span>' . $other_action;
            }
            $list .= '</span>';
            $list .='</span>';
            $list .= self::get_diagram_list($diagram->id, $level + 1, $action);
            $list .= '</li>' . "\n";
        }
        $list .= '</ul>' . "\n";
        return $list;
    }

	/**
	 * get the diagram list as a select.
	 *
	 * @param  Array  Array('selected'=> Integer, 'current_diagram_id'=> Integer, 'none'=> String, 'space' => String, 'uses' => String)
	 * selected current select selected option value
	 * current_diagram_id current diagram id, make you can't select your children for your parent when you edit the diagram
	 * none the first none title, value is 0
	 * space default is ' — '
	 * uses use for add diagram or any other else
	 */
    public static function get_diagram_select($params = array()) {
        $default_params = array('selected' => '', 'none' => T::_('None'), 'current_diagram_id'=>null, 'uses'=> 'post', 'space' => ' — ');
        $output = '';
        $params += $default_params;

        #$output .= '<select name="parent_id" id="diagram_parent"  style="width:100%;">';
        if (!empty($params['none'])) {
            $output .= '<option value="0">' . $params['none'] . '</option>' . "\n";
        }
        // cache the diagram
        self::cache_diagram();
        if ($params['uses'] == 'post') {
            self::cache_diagram_for_post();
            self::$tmp_diagrams = self::$post_diagrams;
        } else {
            self::$tmp_diagrams = self::$parent_diagrams;
        }
        $output .= self::get_diagram_select_option_list($params);

        #$output .= '</select>';
        return $output;
    }

	/**
	 * get the diagram list as a select.
	 *
	 * @param  Array  the same as self::get_diagram_select
	 * @param integer  diagram parent id
	 * @param integer  level
	 */
    public static function get_diagram_select_option_list($params = array(), $parent_id = 0, $level = 0) {
        $output = '';
        if (empty(self::$tmp_diagrams[$parent_id])) {
            return $output;
        }

        foreach(self::$tmp_diagrams[$parent_id] as $diagram) {
            $is_selected = '';
            $disabled = '';
            // if trip the current diagram and children
            if ($diagram->id == $params['current_diagram_id']) {
                continue;
            }

            if (($diagram->type == 'page' || $diagram->type == 'item') && $params['uses'] == 'post') {
                $disabled = ' disabled="disabled" ';
            }

            if ($diagram->id == $params['selected']) {
                    $is_selected = 'selected';
            }
            $output .= '<option ' . $disabled . ' value="' . $diagram->id . '" ' . $is_selected . ' >' . str_repeat($params['space'],$level) . $diagram->title . '</option>' . "\n";
            $output .= self::get_diagram_select_option_list($params, $diagram->id, $level + 1);
        }
        return $output;
    }

    public static function all_as_ul($params = array()) {
        $default = array('type'=>'all', 'selected'=>'', 'home'=>false);
        $params += $default;
        self::cache_diagram();
        self::cache_diagram_for_post();
        self::$tmp_diagrams = self::$post_diagrams;
        $output = self::get_list_as_ul($params);
        return $output;
    }

	/**
	 * get the category list as a ul.
	 *
	 * @param  Array  
	 * @param integer  diagram parent id
	 */
    protected static function get_list_as_ul($args = array(), $parent_id = 0) {
        $output = '';
        if (empty(self::$parent_diagrams[$parent_id])) {
            return $output;
        }
        $output .= '<ul>';
        foreach(self::$parent_diagrams[$parent_id] as $diagram) {
            if ($diagram->uri == '/' and !$args['home']) {
                continue;
            }

            if (empty($parent_id) && $args['type'] != 'all') {
                if ($diagram->type != $args['type']) {
                    continue;
                }
            }
            $selected = '';
            if ($args['selected'] == $diagram->uri) {
                $selected = ' class="selected"';
            }
            $output .= "<li{$selected}>" . html::anchor($diagram->uri, $diagram->title);
            $output .= self::get_list_as_ul($args, $diagram->id);
            $output .= '</li>' . "\n";
        }
        $output .= '</ul>';
        return $output;
    }

    /*
        缓存diagram for post 的列表
    */
    protected static function cache_diagram_for_post() {
        $parent_diagrams = ORM::factory('diagram')->where('type', 'list')->find_all();
        foreach($parent_diagrams as $diagram) {
            self::cache_diagrams_by_parent_id($diagram);
        }
    }

    /*
        缓存使用父类id为key的Diagram 列表
    */
    protected static function cache_diagrams_by_parent_id($diagram) {

        self::$post_diagrams[$diagram->parent_id][$diagram->id] = $diagram;
        if (!empty($diagram->parent_id) && isset(self::$diagrams[$diagram->parent_id]->id)) {
            self::cache_diagrams_by_parent_id(self::$diagrams[$diagram->parent_id]);
        }
    }

    /*
        根据diagram_id 缓存 diagram 的 children
    */
    public static function cache_diagram_children($diagram_id) {
        Diagram::cache_diagram();
        Diagram::cache_children($diagram_id);
        return Diagram::$tmp_diagrams;
    }

    protected static function cache_children($diagram_id) {
        if (!empty(Diagram::$parent_diagrams[$diagram_id])) {
            foreach(Diagram::$parent_diagrams[$diagram_id] as $diagram) {
                Diagram::$tmp_diagrams[] = $diagram->id;
                Diagram::cache_children($diagram->id);
            }
        }
    }

    // get the parent list as array id
    public static function get_parentid_list_as_array($diagram_id) {
        self::cache_diagram();
        if (!empty($diagram_id)) {
            $parent_list[] = $diagram_id;
            $parent_id = isset(self::$diagrams[$diagram_id]->parent_id) ? self::$diagrams[$diagram_id]->parent_id : '';
        } else {
            $parent_list = array();
            $parent_id = '';
        }

        if (!empty($parent_id)) {
            $parent_list  = array_merge($parent_list, self::get_parentid_list_as_array($parent_id));
        }
        return $parent_list;
    }

    // get the current root child by root uri
    public static function get_root($id) {
        self::cache_diagram();
        if (!isset(self::$diagrams[$id])) {
            return new Diagram_Model();
        }
        if (self::$diagrams[$id]->parent_id != 0) {
            return self::get_root(self::$diagrams[$id]->parent_id);
        } else {
            return self::$diagrams[$id];
        }
    }

    // get submenu list as url
    public static function submenu_list($diagram_id, $init) {
        $output = '';
        if (isset(self::$parent_diagrams[$diagram_id])) {
            $count = count(self::$parent_diagrams[$diagram_id]);
            $li = false;
            $ul = false;
            for($i = 0; $i < $count; $i++) {
                $diagram = self::$parent_diagrams[$diagram_id][$i];
                if ($i == 0) {
                    $output .= "<ul>\n";
                    $ul = true;
                }

                $li_class = '';
                $a_class = array();
                if ($init['current_uri'] == $diagram->uri) {
                    if (!empty($init['li_selected_class'])) {
                        $li_class = ' class="' . $init['li_selected_class'] . '"';
                    }
                    if (!empty($init['a_selected_class'])) {
                        $a_class['class'] =$init['a_selected_class'];
                    }
                } else if (!empty($init['li_class'])  or !empty($init['a_class'])) {
                    if (!empty($init['li_class'])) {
                        $li_class = ' class="' . $init['li_class'] . '"';
                    }
                    if (!empty($init['a_class'])) {
                        $a_class['class'] =$init['a_class'];
                    }
                }
                if ($diagram->type == 'item') {
                    $a = $diagram->title;
                    $li_class = ' class="' . $init['item_class'] . '"';
                } else {
                    $a = html::anchor($diagram->uri, $diagram->title, $a_class);
                }
                $output .= "<li$li_class>$a</li>\n";
                $output .=  self::submenu_list($diagram->id, $init);

                if ($li) {
                    $output .=  '</li>';
                } else if ($ul && $i == ($count -1)) {
                    $output .= '</ul>';
                }
            }
        }
        return $output;
    }

    /*
        change diagram display order
    */
    public static function move($action, $id) {
        $diagram = ORM::factory('diagram')->find($id);
        $diagram_order = $diagram->order;

        switch($action) {
            case 'up':
                $next_diagram = ORM::factory('diagram')->where(array('parent_id'=>$diagram->parent_id, 'order<'=>$diagram->order))
                                ->orderby(array('order'=>'DESC'))->find();
                break;

            default:
            case 'down':
                $next_diagram = ORM::factory('diagram')->where(array('parent_id'=>$diagram->parent_id, 'order>'=>$diagram->order))
                                ->orderby(array('order'=>'ASC'))->find();
                break;
        }

        if (!empty($next_diagram) && !empty($next_diagram->order)) {
            $diagram->order = $next_diagram->order;
            $diagram->save();
            $next_diagram->order = $diagram_order;
            $next_diagram->save();
            return True;
        }
        return false;
    }

    // update when diagram was change, use for arlicle_template controller
    public static function cache_uris() {
        $diagrams = ORM::factory('diagram')->find_all();
        $uris = array();
        foreach($diagrams as $diagram) {
            $uris[$diagram->uri] = $diagram->template;
        }
        $cache = Cache::instance();
        $cache->set('theme_uris', $uris, null, 0);
    }

    public static function get_diagram_by_id($diagram_id) {
        self::cache_diagram();
        if (isset(self::$diagrams[$diagram_id])) {
            return self::$diagrams[$diagram_id];
        }
    }

}
